autocompile -> auto-compile
[bpt/guile.git] / maint.mk
CommitLineData
c84bdaf6
LC
1# -*-Makefile-*-
2# This Makefile fragment tries to be general-purpose enough to be
3# used by many projects via the gnulib maintainer-makefile module.
4
61cd9dc9 5## Copyright (C) 2001-2010 Free Software Foundation, Inc.
c84bdaf6
LC
6##
7## This program is free software: you can redistribute it and/or modify
8## it under the terms of the GNU General Public License as published by
9## the Free Software Foundation, either version 3 of the License, or
10## (at your option) any later version.
11##
12## This program is distributed in the hope that it will be useful,
13## but WITHOUT ANY WARRANTY; without even the implied warranty of
14## MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
15## GNU General Public License for more details.
16##
17## You should have received a copy of the GNU General Public License
18## along with this program. If not, see <http://www.gnu.org/licenses/>.
19
20# This is reported not to work with make-3.79.1
21# ME := $(word $(words $(MAKEFILE_LIST)),$(MAKEFILE_LIST))
22ME := maint.mk
23
24# Override this in cfg.mk if you use a non-standard build-aux directory.
25build_aux ?= $(srcdir)/build-aux
26
27# Do not save the original name or timestamp in the .tar.gz file.
28# Use --rsyncable if available.
29gzip_rsyncable := \
a927b6c1
LC
30 $(shell gzip --help 2>/dev/null|grep rsyncable >/dev/null \
31 && printf %s --rsyncable)
c84bdaf6
LC
32GZIP_ENV = '--no-name --best $(gzip_rsyncable)'
33
c84bdaf6
LC
34GIT = git
35VC = $(GIT)
36VC-tag = git tag -s -m '$(VERSION)' -u '$(gpg_key_ID)'
37
38VC_LIST = $(build_aux)/vc-list-files -C $(srcdir)
39
61cd9dc9
LC
40# You can override this variable in cfg.mk to set your own regexp
41# matching files to ignore.
42VC_LIST_ALWAYS_EXCLUDE_REGEX ?= ^$$
43
44# This is to preprocess robustly the output of $(VC_LIST), so that even
45# when $(srcdir) is a pathological name like "....", the leading sed command
46# removes only the intended prefix.
47_dot_escaped_srcdir = $(subst .,\.,$(srcdir))
48
49# Post-process $(VC_LIST) output, prepending $(srcdir)/, but only
50# when $(srcdir) is not ".".
51ifeq ($(srcdir),.)
52_prepend_srcdir_prefix =
53else
54_prepend_srcdir_prefix = | sed 's|^|$(srcdir)/|'
55endif
56
57# In order to be able to consistently filter "."-relative names,
58# (i.e., with no $(srcdir) prefix), this definition is careful to
59# remove any $(srcdir) prefix, and to restore what it removes.
c84bdaf6 60VC_LIST_EXCEPT = \
61cd9dc9
LC
61 $(VC_LIST) | sed 's|^$(_dot_escaped_srcdir)/||' \
62 | if test -f $(srcdir)/.x-$@; then grep -vEf $(srcdir)/.x-$@; \
63 else grep -Ev -e "$${VC_LIST_EXCEPT_DEFAULT-ChangeLog}"; fi \
64 | grep -Ev -e '$(VC_LIST_ALWAYS_EXCLUDE_REGEX)' \
65 $(_prepend_srcdir_prefix)
c84bdaf6
LC
66
67ifeq ($(origin prev_version_file), undefined)
68 prev_version_file = $(srcdir)/.prev-version
69endif
70
71PREV_VERSION := $(shell cat $(prev_version_file) 2>/dev/null)
72VERSION_REGEXP = $(subst .,\.,$(VERSION))
73PREV_VERSION_REGEXP = $(subst .,\.,$(PREV_VERSION))
74
75ifeq ($(VC),$(GIT))
76this-vc-tag = v$(VERSION)
77this-vc-tag-regexp = v$(VERSION_REGEXP)
78else
79tag-package = $(shell echo "$(PACKAGE)" | tr '[:lower:]' '[:upper:]')
80tag-this-version = $(subst .,_,$(VERSION))
81this-vc-tag = $(tag-package)-$(tag-this-version)
82this-vc-tag-regexp = $(this-vc-tag)
83endif
84my_distdir = $(PACKAGE)-$(VERSION)
85
86# Old releases are stored here.
87release_archive_dir ?= ../release
88
414e4441
LC
89# Override gnu_rel_host and url_dir_list in cfg.mk if these are not right.
90# Use alpha.gnu.org for alpha and beta releases.
91# Use ftp.gnu.org for stable releases.
92gnu_ftp_host-alpha = alpha.gnu.org
93gnu_ftp_host-beta = alpha.gnu.org
94gnu_ftp_host-stable = ftp.gnu.org
95gnu_rel_host ?= $(gnu_ftp_host-$(RELEASE_TYPE))
96
97ifeq ($(gnu_rel_host),ftp.gnu.org)
98url_dir_list ?= http://ftpmirror.gnu.org/$(PACKAGE)
99else
100url_dir_list ?= ftp://$(gnu_rel_host)/gnu/$(PACKAGE)
101endif
102
1cd4fffc
LC
103# Override this in cfg.mk if you are using a different format in your
104# NEWS file.
105today = $(shell date +%Y-%m-%d)
9157d901
LC
106
107# Select which lines of NEWS are searched for $(news-check-regexp).
108# This is a sed line number spec. The default says that we search
109# lines 1..10 of NEWS for $(news-check-regexp).
110# If you want to search only line 3 or only lines 20-22, use "3" or "20,22".
111news-check-lines-spec ?= 1,10
1cd4fffc
LC
112news-check-regexp ?= '^\*.* $(VERSION_REGEXP) \($(today)\)'
113
c84bdaf6
LC
114# Prevent programs like 'sort' from considering distinct strings to be equal.
115# Doing it here saves us from having to set LC_ALL elsewhere in this file.
116export LC_ALL = C
117
118## --------------- ##
119## Sanity checks. ##
120## --------------- ##
121
122_cfg_mk := $(shell test -f $(srcdir)/cfg.mk && echo '$(srcdir)/cfg.mk')
123
124# Collect the names of rules starting with `sc_'.
125syntax-check-rules := $(sort $(shell sed -n 's/^\(sc_[a-zA-Z0-9_-]*\):.*/\1/p' \
126 $(srcdir)/$(ME) $(_cfg_mk)))
127.PHONY: $(syntax-check-rules)
128
129local-checks-available = \
130 $(syntax-check-rules)
131.PHONY: $(local-checks-available)
132
133# Arrange to print the name of each syntax-checking rule just before running it.
134$(syntax-check-rules): %: %.m
dde9c5a4
LC
135sc_m_rules_ = $(patsubst %, %.m, $(syntax-check-rules))
136.PHONY: $(sc_m_rules_)
137$(sc_m_rules_):
c84bdaf6 138 @echo $(patsubst sc_%.m, %, $@)
a927b6c1
LC
139 @date +%s.%N > .sc-start-$(basename $@)
140
141# Compute and print the elapsed time for each syntax-check rule.
142sc_z_rules_ = $(patsubst %, %.z, $(syntax-check-rules))
143.PHONY: $(sc_z_rules_)
144$(sc_z_rules_): %.z: %
145 @end=$$(date +%s.%N); \
146 start=$$(cat .sc-start-$*); \
147 rm -f .sc-start-$*; \
148 awk -v s=$$start -v e=$$end \
149 'END {printf "%.2f $(patsubst sc_%,%,$*)\n", e - s}' < /dev/null
150
151# The patsubst here is to replace each sc_% rule with its sc_%.z wrapper
152# that computes and prints elapsed time.
153local-check := \
154 $(patsubst sc_%, sc_%.z, \
155 $(filter-out $(local-checks-to-skip), $(local-checks-available)))
c84bdaf6
LC
156
157syntax-check: $(local-check)
a927b6c1
LC
158
159# _sc_search_regexp
160#
161# This macro searches for a given construct in the selected files and
162# then takes some action.
163#
164# Parameters (shell variables):
165#
166# prohibit | require
167#
168# Regular expression (ERE) denoting either a forbidden construct
169# or a required construct. Those arguments are exclusive.
170#
171# in_vc_files | in_files
172#
173# grep-E-style regexp denoting the files to check. If no files
174# are specified the default are all the files that are under
175# version control.
176#
177# containing | non_containing
178#
179# Select the files (non) containing strings matching this regexp.
180# If both arguments are specified then CONTAINING takes
181# precedence.
182#
183# with_grep_options
184#
185# Extra options for grep.
186#
187# ignore_case
188#
189# Ignore case.
190#
191# halt
192#
193# Message to display before to halting execution.
194
195# By default, _sc_search_regexp does not ignore case.
c84bdaf6 196export ignore_case =
a927b6c1 197_ignore_case = $$(test -n "$$ignore_case" && printf %s -i || :)
c84bdaf6 198
a927b6c1
LC
199define _sc_say_and_exit
200 dummy=; : so we do not need a semicolon before each use; \
201 { printf '%s\n' "$(ME): $$msg" 1>&2; exit 1; };
202endef
203
204# _sc_search_regexp used to be named _prohibit_regexp. However,
205# upgrading to the new definition and leaving the old name undefined
206# would usually convert each custom rule using $(_prohibit_regexp)
207# (usually defined in cfg.mk) into a no-op. This definition ensures
208# that people know right away if they're still using the old name.
209# FIXME: remove in 2012.
210_prohibit_regexp = \
211 $(error '*** you need to s/_prohibit_regexp/_sc_search_regexp/, and adapt')
212
213define _sc_search_regexp
214 dummy=; : so we do not need a semicolon before each use; \
215 \
216 : Check arguments; \
217 test -n "$$prohibit" && test -n "$$require" \
218 && { msg='Cannot specify both prohibit and require' \
219 $(_sc_say_and_exit) } || :; \
220 test -z "$$prohibit" && test -z "$$require" \
221 && { msg='Should specify either prohibit or require' \
222 $(_sc_say_and_exit) } || :; \
223 test -n "$$in_vc_files" && test -n "$$in_files" \
224 && { msg='Cannot specify both in_vc_files and in_files' \
225 $(_sc_say_and_exit) } || :; \
226 test "x$$halt" != x \
227 || { msg='halt not defined' $(_sc_say_and_exit) }; \
228 \
229 : Filter by file name; \
230 if test -n "$$in_files"; then \
231 files=$$(find $(srcdir) | grep -E "$$in_files"); \
232 else \
233 files=$$($(VC_LIST_EXCEPT)); \
234 if test -n "$$in_vc_files"; then \
235 files=$$(echo "$$files" | grep -E "$$in_vc_files"); \
236 fi; \
237 fi; \
238 \
239 : Filter by content; \
240 test -n "$$files" && test -n "$$containing" \
241 && { files=$$(grep -l "$$containing" $$files); } || :; \
242 test -n "$$files" && test -n "$$non_containing" \
243 && { files=$$(grep -vl "$$non_containing" $$files); } || :; \
244 \
245 : Check for the construct; \
246 if test -n "$$files"; then \
247 if test -n "$$prohibit"; then \
248 grep $$with_grep_options $(_ignore_case) -nE "$$prohibit" $$files \
249 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
250 else \
251 grep $$with_grep_options $(_ignore_case) -LE "$$require" $$files \
252 | grep . \
253 && { msg="$$halt" $(_sc_say_and_exit) } || :; \
254 fi \
255 else :; \
256 fi || :;
c84bdaf6
LC
257endef
258
259sc_avoid_if_before_free:
260 @$(build_aux)/useless-if-before-free \
261 $(useless_free_options) \
262 $$($(VC_LIST_EXCEPT) | grep -v useless-if-before-free) && \
263 { echo '$(ME): found useless "if" before "free" above' 1>&2; \
264 exit 1; } || :
265
266sc_cast_of_argument_to_free:
a927b6c1
LC
267 @prohibit='\<free *\( *\(' halt='don'\''t cast free argument' \
268 $(_sc_search_regexp)
c84bdaf6
LC
269
270sc_cast_of_x_alloc_return_value:
a927b6c1
LC
271 @prohibit='\*\) *x(m|c|re)alloc\>' \
272 halt='don'\''t cast x*alloc return value' \
273 $(_sc_search_regexp)
c84bdaf6
LC
274
275sc_cast_of_alloca_return_value:
a927b6c1
LC
276 @prohibit='\*\) *alloca\>' \
277 halt='don'\''t cast alloca return value' \
278 $(_sc_search_regexp)
c84bdaf6
LC
279
280sc_space_tab:
a927b6c1
LC
281 @prohibit='[ ] ' \
282 halt='found SPACE-TAB sequence; remove the SPACE' \
283 $(_sc_search_regexp)
c84bdaf6
LC
284
285# Don't use *scanf or the old ato* functions in `real' code.
286# They provide no error checking mechanism.
287# Instead, use strto* functions.
288sc_prohibit_atoi_atof:
a927b6c1
LC
289 @prohibit='\<([fs]?scanf|ato([filq]|ll)) *\(' \
290 halt='do not use *scan''f, ato''f, ato''i, ato''l, ato''ll or ato''q' \
291 $(_sc_search_regexp)
c84bdaf6
LC
292
293# Use STREQ rather than comparing strcmp == 0, or != 0.
294sc_prohibit_strcmp:
295 @grep -nE '! *str''cmp *\(|\<str''cmp *\([^)]+\) *==' \
296 $$($(VC_LIST_EXCEPT)) \
297 | grep -vE ':# *define STREQ\(' && \
298 { echo '$(ME): use STREQ in place of the above uses of str''cmp' \
299 1>&2; exit 1; } || :
300
301# Pass EXIT_*, not number, to usage, exit, and error (when exiting)
414e4441
LC
302# Convert all uses automatically, via these two commands:
303# git grep -l '\<exit *(1)' \
304# | grep -vEf .x-sc_prohibit_magic_number_exit \
305# | xargs --no-run-if-empty \
306# perl -pi -e 's/(^|[^.])\b(exit ?)\(1\)/$1$2(EXIT_FAILURE)/'
307# git grep -l '\<exit *(0)' \
308# | grep -vEf .x-sc_prohibit_magic_number_exit \
309# | xargs --no-run-if-empty \
310# perl -pi -e 's/(^|[^.])\b(exit ?)\(0\)/$1$2(EXIT_SUCCESS)/'
c84bdaf6 311sc_prohibit_magic_number_exit:
a927b6c1
LC
312 @prohibit='(^|[^.])\<(usage|exit) ?\([0-9]|\<error ?\([1-9][0-9]*,' \
313 halt='use EXIT_* values rather than magic number' \
314 $(_sc_search_regexp)
c84bdaf6
LC
315
316# Using EXIT_SUCCESS as the first argument to error is misleading,
317# since when that parameter is 0, error does not exit. Use `0' instead.
318sc_error_exit_success:
a927b6c1
LC
319 @prohibit='error *\(EXIT_SUCCESS,' \
320 in_vc_files='\.[chly]$$' \
321 halt='found error (EXIT_SUCCESS' \
322 $(_sc_search_regexp)
c84bdaf6
LC
323
324# `FATAL:' should be fully upper-cased in error messages
325# `WARNING:' should be fully upper-cased, or fully lower-cased
326sc_error_message_warn_fatal:
a927b6c1 327 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
328 | grep -E '"Warning|"Fatal|"fatal' && \
329 { echo '$(ME): use FATAL, WARNING or warning' 1>&2; \
330 exit 1; } || :
331
332# Error messages should not start with a capital letter
333sc_error_message_uppercase:
a927b6c1 334 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
335 | grep -E '"[A-Z]' \
336 | grep -vE '"FATAL|"WARNING|"Java|"C#|PRIuMAX' && \
337 { echo '$(ME): found capitalized error message' 1>&2; \
338 exit 1; } || :
339
340# Error messages should not end with a period
341sc_error_message_period:
a927b6c1 342 @grep -nEA2 '[^rp]error *\(' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
343 | grep -E '[^."]\."' && \
344 { echo '$(ME): found error message ending in period' 1>&2; \
345 exit 1; } || :
346
347sc_file_system:
a927b6c1
LC
348 @prohibit=file''system \
349 ignore_case=1 \
350 halt='found use of "file''system"; spell it "file system"' \
351 $(_sc_search_regexp)
c84bdaf6
LC
352
353# Don't use cpp tests of this symbol. All code assumes config.h is included.
354sc_prohibit_have_config_h:
a927b6c1
LC
355 @prohibit='^# *if.*HAVE''_CONFIG_H' \
356 halt='found use of HAVE''_CONFIG_H; remove' \
357 $(_sc_search_regexp)
c84bdaf6
LC
358
359# Nearly all .c files must include <config.h>. However, we also permit this
360# via inclusion of a package-specific header, if cfg.mk specified one.
361# config_h_header must be suitable for grep -E.
362config_h_header ?= <config\.h>
363sc_require_config_h:
a927b6c1
LC
364 @require='^# *include $(config_h_header)' \
365 in_vc_files='\.c$$' \
366 halt='the above files do not include <config.h>' \
367 $(_sc_search_regexp)
c84bdaf6
LC
368
369# You must include <config.h> before including any other header file.
370# This can possibly be via a package-specific header, if given by cfg.mk.
371sc_require_config_h_first:
372 @if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
373 fail=0; \
374 for i in $$($(VC_LIST_EXCEPT) | grep '\.c$$'); do \
375 grep '^# *include\>' $$i | sed 1q \
376 | grep -E '^# *include $(config_h_header)' > /dev/null \
377 || { echo $$i; fail=1; }; \
378 done; \
379 test $$fail = 1 && \
380 { echo '$(ME): the above files include some other header' \
381 'before <config.h>' 1>&2; exit 1; } || :; \
382 else :; \
383 fi
384
385sc_prohibit_HAVE_MBRTOWC:
a927b6c1
LC
386 @prohibit='\bHAVE_MBRTOWC\b' \
387 halt="do not use $$prohibit; it is always defined" \
388 $(_sc_search_regexp)
c84bdaf6
LC
389
390# To use this "command" macro, you must first define two shell variables:
391# h: the header, enclosed in <> or ""
392# re: a regular expression that matches IFF something provided by $h is used.
a927b6c1 393define _sc_header_without_use
c84bdaf6
LC
394 dummy=; : so we do not need a semicolon before each use; \
395 h_esc=`echo "$$h"|sed 's/\./\\\\./g'`; \
396 if $(VC_LIST_EXCEPT) | grep -l '\.c$$' > /dev/null; then \
397 files=$$(grep -l '^# *include '"$$h_esc" \
398 $$($(VC_LIST_EXCEPT) | grep '\.c$$')) && \
399 grep -LE "$$re" $$files | grep . && \
400 { echo "$(ME): the above files include $$h but don't use it" \
401 1>&2; exit 1; } || :; \
402 else :; \
403 fi
404endef
405
406# Prohibit the inclusion of assert.h without an actual use of assert.
407sc_prohibit_assert_without_use:
a927b6c1 408 @h='<assert.h>' re='\<assert *\(' $(_sc_header_without_use)
c84bdaf6
LC
409
410# Prohibit the inclusion of close-stream.h without an actual use.
411sc_prohibit_close_stream_without_use:
a927b6c1 412 @h='"close-stream.h"' re='\<close_stream *\(' $(_sc_header_without_use)
c84bdaf6
LC
413
414# Prohibit the inclusion of getopt.h without an actual use.
415sc_prohibit_getopt_without_use:
a927b6c1 416 @h='<getopt.h>' re='\<getopt(_long)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
417
418# Don't include quotearg.h unless you use one of its functions.
419sc_prohibit_quotearg_without_use:
a927b6c1 420 @h='"quotearg.h"' re='\<quotearg(_[^ ]+)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
421
422# Don't include quote.h unless you use one of its functions.
423sc_prohibit_quote_without_use:
a927b6c1 424 @h='"quote.h"' re='\<quote(_n)? *\(' $(_sc_header_without_use)
c84bdaf6
LC
425
426# Don't include this header unless you use one of its functions.
427sc_prohibit_long_options_without_use:
428 @h='"long-options.h"' re='\<parse_long_options *\(' \
a927b6c1 429 $(_sc_header_without_use)
c84bdaf6
LC
430
431# Don't include this header unless you use one of its functions.
432sc_prohibit_inttostr_without_use:
433 @h='"inttostr.h"' re='\<(off|[iu]max|uint)tostr *\(' \
a927b6c1 434 $(_sc_header_without_use)
c84bdaf6 435
61cd9dc9
LC
436# Don't include this header unless you use one of its functions.
437sc_prohibit_ignore_value_without_use:
438 @h='"ignore-value.h"' re='\<ignore_(value|ptr) *\(' \
a927b6c1 439 $(_sc_header_without_use)
61cd9dc9 440
c84bdaf6
LC
441# Don't include this header unless you use one of its functions.
442sc_prohibit_error_without_use:
443 @h='"error.h"' \
444 re='\<error(_at_line|_print_progname|_one_per_line|_message_count)? *\('\
a927b6c1 445 $(_sc_header_without_use)
c84bdaf6
LC
446
447# Don't include xalloc.h unless you use one of its functions.
448# Consider these symbols:
449# perl -lne '/^# *define (\w+)\(/ and print $1' lib/xalloc.h|grep -v '^__';
a927b6c1 450# perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/xalloc.h
c84bdaf6
LC
451# Divide into two sets on case, and filter each through this:
452# | sort | perl -MRegexp::Assemble -le \
453# 'print Regexp::Assemble->new(file => "/dev/stdin")->as_string'|sed 's/\?://g'
454# Note this was produced by the above:
61cd9dc9
LC
455# _xa1 = \
456#x(((2n?)?re|c(har)?|n(re|m)|z)alloc|alloc_(oversized|die)|m(alloc|emdup)|strdup)
457# But we can do better, in at least two ways:
458# 1) take advantage of two "dup"-suffixed strings:
459# x(((2n?)?re|c(har)?|n(re|m)|[mz])alloc|alloc_(oversized|die)|(mem|str)dup)
460# 2) notice that "c(har)?|[mz]" is equivalent to the shorter and more readable
461# "char|[cmz]"
462# x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
463_xa1 = x(((2n?)?re|char|n(re|m)|[cmz])alloc|alloc_(oversized|die)|(mem|str)dup)
c84bdaf6
LC
464_xa2 = X([CZ]|N?M)ALLOC
465sc_prohibit_xalloc_without_use:
466 @h='"xalloc.h"' \
467 re='\<($(_xa1)|$(_xa2)) *\('\
a927b6c1 468 $(_sc_header_without_use)
c84bdaf6 469
dde9c5a4 470# Extract function names:
a927b6c1 471# perl -lne '/^(?:extern )?(?:void|char) \*?(\w+) *\(/ and print $1' lib/hash.h
dde9c5a4
LC
472_hash_re = \
473clear|delete|free|get_(first|next)|insert|lookup|print_statistics|reset_tuning
474_hash_fn = \<($(_hash_re)) *\(
475_hash_struct = (struct )?\<[Hh]ash_(table|tuning)\>
476sc_prohibit_hash_without_use:
477 @h='"hash.h"' \
478 re='$(_hash_fn)|$(_hash_struct)'\
a927b6c1 479 $(_sc_header_without_use)
dde9c5a4
LC
480
481sc_prohibit_hash_pjw_without_use:
482 @h='"hash-pjw.h"' \
483 re='\<hash_pjw *\(' \
a927b6c1 484 $(_sc_header_without_use)
dde9c5a4 485
c84bdaf6
LC
486sc_prohibit_safe_read_without_use:
487 @h='"safe-read.h"' re='(\<SAFE_READ_ERROR\>|\<safe_read *\()' \
a927b6c1 488 $(_sc_header_without_use)
c84bdaf6
LC
489
490sc_prohibit_argmatch_without_use:
491 @h='"argmatch.h"' \
492 re='(\<(ARRAY_CARDINALITY|X?ARGMATCH(|_TO_ARGUMENT|_VERIFY))\>|\<argmatch(_exit_fn|_(in)?valid) *\()' \
a927b6c1 493 $(_sc_header_without_use)
c84bdaf6
LC
494
495sc_prohibit_canonicalize_without_use:
496 @h='"canonicalize.h"' \
497 re='CAN_(EXISTING|ALL_BUT_LAST|MISSING)|canonicalize_(mode_t|filename_mode)' \
a927b6c1 498 $(_sc_header_without_use)
c84bdaf6
LC
499
500sc_prohibit_root_dev_ino_without_use:
501 @h='"root-dev-ino.h"' \
502 re='(\<ROOT_DEV_INO_(CHECK|WARN)\>|\<get_root_dev_ino *\()' \
a927b6c1 503 $(_sc_header_without_use)
c84bdaf6
LC
504
505sc_prohibit_openat_without_use:
506 @h='"openat.h"' \
507 re='\<(openat_(permissive|needs_fchdir|(save|restore)_fail)|l?(stat|ch(own|mod))at|(euid)?accessat)\>' \
a927b6c1 508 $(_sc_header_without_use)
c84bdaf6
LC
509
510# Prohibit the inclusion of c-ctype.h without an actual use.
511ctype_re = isalnum|isalpha|isascii|isblank|iscntrl|isdigit|isgraph|islower\
512|isprint|ispunct|isspace|isupper|isxdigit|tolower|toupper
513sc_prohibit_c_ctype_without_use:
a927b6c1
LC
514 @h='[<"]c-ctype.h[">]' re='\<c_($(ctype_re)) *\(' \
515 $(_sc_header_without_use)
c84bdaf6
LC
516
517_empty =
518_sp = $(_empty) $(_empty)
519# The following list was generated by running:
520# man signal.h|col -b|perl -ne '/bsd_signal.*;/.../sigwaitinfo.*;/ and print' \
521# | perl -lne '/^\s+(?:int|void).*?(\w+).*/ and print $1' | fmt
522_sig_functions = \
523 bsd_signal kill killpg pthread_kill pthread_sigmask raise sigaction \
524 sigaddset sigaltstack sigdelset sigemptyset sigfillset sighold sigignore \
525 siginterrupt sigismember signal sigpause sigpending sigprocmask sigqueue \
526 sigrelse sigset sigsuspend sigtimedwait sigwait sigwaitinfo
527_sig_function_re = $(subst $(_sp),|,$(strip $(_sig_functions)))
528# The following were extracted from "man signal.h" manually.
529_sig_types_and_consts = \
530 MINSIGSTKSZ SA_NOCLDSTOP SA_NOCLDWAIT SA_NODEFER SA_ONSTACK \
531 SA_RESETHAND SA_RESTART SA_SIGINFO SIGEV_NONE SIGEV_SIGNAL \
532 SIGEV_THREAD SIGSTKSZ SIG_BLOCK SIG_SETMASK SIG_UNBLOCK SS_DISABLE \
533 SS_ONSTACK mcontext_t pid_t sig_atomic_t sigevent siginfo_t sigset_t \
534 sigstack sigval stack_t ucontext_t
535# generated via this:
536# perl -lne '/^#ifdef (SIG\w+)/ and print $1' lib/sig2str.c|sort -u|fmt -70
537_sig_names = \
538 SIGABRT SIGALRM SIGALRM1 SIGBUS SIGCANCEL SIGCHLD SIGCLD SIGCONT \
539 SIGDANGER SIGDIL SIGEMT SIGFPE SIGFREEZE SIGGRANT SIGHUP SIGILL \
540 SIGINFO SIGINT SIGIO SIGIOT SIGKAP SIGKILL SIGKILLTHR SIGLOST SIGLWP \
541 SIGMIGRATE SIGMSG SIGPHONE SIGPIPE SIGPOLL SIGPRE SIGPROF SIGPWR \
542 SIGQUIT SIGRETRACT SIGSAK SIGSEGV SIGSOUND SIGSTKFLT SIGSTOP SIGSYS \
543 SIGTERM SIGTHAW SIGTRAP SIGTSTP SIGTTIN SIGTTOU SIGURG SIGUSR1 \
544 SIGUSR2 SIGVIRT SIGVTALRM SIGWAITING SIGWINCH SIGWIND SIGWINDOW \
545 SIGXCPU SIGXFSZ
546_sig_syms_re = $(subst $(_sp),|,$(strip $(_sig_names) $(_sig_types_and_consts)))
547
548# Prohibit the inclusion of signal.h without an actual use.
549sc_prohibit_signal_without_use:
550 @h='<signal.h>' \
551 re='\<($(_sig_function_re)) *\(|\<($(_sig_syms_re))\>' \
a927b6c1
LC
552 $(_sc_header_without_use)
553
554# Prohibit the inclusion of strings.h without a sensible use.
555# Using the likes of bcmp, bcopy, bzero, index or rindex is not sensible.
556sc_prohibit_strings_without_use:
557 @h='<strings.h>' \
558 re='\<(strn?casecmp|ffs(ll)?)\>' \
559 $(_sc_header_without_use)
560
561# Get the list of symbol names with this:
562# perl -lne '/^# *define (\w+)\(/ and print $1' lib/intprops.h|grep -v '^s'|fmt
563_intprops_names = \
564 TYPE_IS_INTEGER TYPE_TWOS_COMPLEMENT TYPE_ONES_COMPLEMENT \
565 TYPE_SIGNED_MAGNITUDE TYPE_SIGNED TYPE_MINIMUM TYPE_MAXIMUM \
566 INT_STRLEN_BOUND INT_BUFSIZE_BOUND
567_intprops_syms_re = $(subst $(_sp),|,$(strip $(_intprops_names)))
568# Prohibit the inclusion of intprops.h without an actual use.
569sc_prohibit_intprops_without_use:
570 @h='"intprops.h"' \
571 re='\<($(_intprops_syms_re)) *\(' \
572 $(_sc_header_without_use)
c84bdaf6
LC
573
574sc_obsolete_symbols:
a927b6c1
LC
575 @prohibit='\<(HAVE''_FCNTL_H|O''_NDELAY)\>' \
576 halt='do not use HAVE''_FCNTL_H or O'_NDELAY \
577 $(_sc_search_regexp)
c84bdaf6
LC
578
579# FIXME: warn about definitions of EXIT_FAILURE, EXIT_SUCCESS, STREQ
580
581# Each nonempty ChangeLog line must start with a year number, or a TAB.
582sc_changelog:
a927b6c1
LC
583 @prohibit='^[^12 ]' \
584 in_vc_files='^ChangeLog$$' \
585 halt='found unexpected prefix in a ChangeLog' \
586 $(_sc_search_regexp)
c84bdaf6
LC
587
588# Ensure that each .c file containing a "main" function also
589# calls set_program_name.
590sc_program_name:
a927b6c1
LC
591 @require='set_program_name *\(m?argv\[0\]\);' \
592 in_vc_files='\.c$$' \
0f00f2c3 593 containing='\<main *(' \
a927b6c1
LC
594 halt='the above files do not call set_program_name' \
595 $(_sc_search_regexp)
c84bdaf6 596
0f00f2c3
LC
597# Ensure that each .c file containing a "main" function also
598# calls bindtextdomain.
599sc_bindtextdomain:
600 @require='bindtextdomain *\(' \
601 in_vc_files='\.c$$' \
602 containing='\<main *(' \
603 halt='the above files do not call bindtextdomain' \
604 $(_sc_search_regexp)
605
c84bdaf6
LC
606# Require that the final line of each test-lib.sh-using test be this one:
607# Exit $fail
608# Note: this test requires GNU grep's --label= option.
609Exit_witness_file ?= tests/test-lib.sh
610Exit_base := $(notdir $(Exit_witness_file))
611sc_require_test_exit_idiom:
612 @if test -f $(srcdir)/$(Exit_witness_file); then \
613 die=0; \
614 for i in $$(grep -l -F 'srcdir/$(Exit_base)' \
615 $$($(VC_LIST) tests)); do \
616 tail -n1 $$i | grep '^Exit .' > /dev/null \
617 && : || { die=1; echo $$i; } \
618 done; \
619 test $$die = 1 && \
620 { echo 1>&2 '$(ME): the final line in each of the above is not:'; \
621 echo 1>&2 'Exit something'; \
622 exit 1; } || :; \
623 fi
624
625sc_the_the:
a927b6c1
LC
626 @prohibit='\<the ''the\>' \
627 ignore_case=1 \
628 halt='found use of "the ''the";' \
629 $(_sc_search_regexp)
c84bdaf6
LC
630
631sc_trailing_blank:
a927b6c1
LC
632 @prohibit='[ ]$$' \
633 halt='found trailing blank(s)' \
634 $(_sc_search_regexp)
c84bdaf6
LC
635
636# Match lines like the following, but where there is only one space
637# between the options and the description:
638# -D, --all-repeated[=delimit-method] print all duplicate lines\n
639longopt_re = --[a-z][0-9A-Za-z-]*(\[?=[0-9A-Za-z-]*\]?)?
640sc_two_space_separator_in_usage:
a927b6c1
LC
641 @prohibit='^ *(-[A-Za-z],)? $(longopt_re) [^ ].*\\$$' \
642 halt='help2man requires at least two spaces between an option and its description'\
643 $(_sc_search_regexp)
c84bdaf6
LC
644
645# Look for diagnostics that aren't marked for translation.
646# This won't find any for which error's format string is on a separate line.
647sc_unmarked_diagnostics:
648 @grep -nE \
a927b6c1 649 '\<error *\([^"]*"[^"]*[a-z]{3}' $$($(VC_LIST_EXCEPT)) \
c84bdaf6
LC
650 | grep -v '_''(' && \
651 { echo '$(ME): found unmarked diagnostic(s)' 1>&2; \
652 exit 1; } || :
653
654# Avoid useless parentheses like those in this example:
655# #if defined (SYMBOL) || defined (SYM2)
656sc_useless_cpp_parens:
a927b6c1
LC
657 @prohibit='^# *if .*defined *\(' \
658 halt='found useless parentheses in cpp directive' \
659 $(_sc_search_regexp)
660
661# List headers for which HAVE_HEADER_H is always true, assuming you are
662# using the appropriate gnulib module. CAUTION: for each "unnecessary"
663# #if HAVE_HEADER_H that you remove, be sure that your project explicitly
664# requires the gnulib module that guarantees the usability of that header.
665gl_assured_headers_ = \
666 cd $(gnulib_dir)/lib && echo *.in.h|sed 's/\.in\.h//g'
667
668# Convert the list of names to upper case, and replace each space with "|".
669az_ = abcdefghijklmnopqrstuvwxyz
670AZ_ = ABCDEFGHIJKLMNOPQRSTUVWXYZ
671gl_header_upper_case_or_ = \
672 $$($(gl_assured_headers_) \
673 | tr $(az_)/.- $(AZ_)___ \
674 | tr -s ' ' '|' \
675 )
676sc_prohibit_always_true_header_tests:
677 @or=$(gl_header_upper_case_or_); \
678 re="HAVE_($$or)_H"; \
679 prohibit='\<'"$$re"'\>' \
0f00f2c3
LC
680 halt=$$(printf '%s\n' \
681 'do not test the above HAVE_<header>_H symbol(s);' \
682 ' with the corresponding gnulib module, they are always true') \
a927b6c1
LC
683 $(_sc_search_regexp)
684
685# ==================================================================
686gl_other_headers_ ?= \
687 intprops.h \
688 openat.h \
689 stat-macros.h
690
691# Perl -lne code to extract "significant" cpp-defined symbols from a
692# gnulib header file, eliminating a few common false-positives.
693gl_extract_significant_defines_ = \
694 /^\# *define ([^_ (][^ (]*)(\s*\(|\s+\w+)/\
695 && $$2 !~ /(?:rpl_|_used_without_)/\
696 && $$1 !~ /^(?:NSIG|ATTRIBUTE_NORETURN)$$/\
697 and print $$1
698
699# Create a list of regular expressions matching the names
700# of macros that are guaranteed to be defined by parts of gnulib.
701define def_sym_regex
702 gen_h=$(gl_generated_headers_); \
703 (cd $(gnulib_dir)/lib; \
704 for f in *.in.h $(gl_other_headers_); do \
705 perl -lne '$(gl_extract_significant_defines_)' $$f; \
706 done; \
707 ) | sort -u \
708 | grep -Ev '^ATTRIBUTE_NORETURN' \
709 | sed 's/^/^ *# *(define|undef) */;s/$$/\\>/'
710endef
711
712# Don't define macros that we already get from gnulib header files.
713sc_prohibit_always-defined_macros:
714 @if test -d $(gnulib_dir); then \
715 case $$(echo all: | grep -l -f - Makefile) in Makefile);; *) \
716 echo '$(ME): skipping $@: you lack GNU grep' 1>&2; exit 0;; \
717 esac; \
718 $(def_sym_regex) | grep -E -f - $$($(VC_LIST_EXCEPT)) \
719 && { echo '$(ME): define the above via some gnulib .h file' \
720 1>&2; exit 1; } || :; \
721 fi
722# ==================================================================
723
724# Prohibit checked in backup files.
725sc_prohibit_backup_files:
726 @$(VC_LIST) | grep '~$$' && \
727 { echo '$(ME): found version controlled backup file' 1>&2; \
728 exit 1; } || :
c84bdaf6
LC
729
730# Require the latest GPL.
731sc_GPL_version:
a927b6c1
LC
732 @prohibit='either ''version [^3]' \
733 halt='GPL vN, N!=3' \
734 $(_sc_search_regexp)
c84bdaf6 735
61cd9dc9
LC
736# Require the latest GFDL. Two regexp, since some .texi files end up
737# line wrapping between 'Free Documentation License,' and 'Version'.
738_GFDL_regexp = (Free ''Documentation.*Version 1\.[^3]|Version 1\.[^3] or any)
739sc_GFDL_version:
a927b6c1
LC
740 @prohibit='$(_GFDL_regexp)' \
741 halt='GFDL vN, N!=3' \
742 $(_sc_search_regexp)
743
0f00f2c3
LC
744# Don't use Texinfo's @acronym{}.
745# http://lists.gnu.org/archive/html/bug-gnulib/2010-03/msg00321.html
a927b6c1
LC
746texinfo_suffix_re_ ?= \.(txi|texi(nfo)?)$$
747sc_texinfo_acronym:
748 @prohibit='@acronym\{' \
749 in_vc_files='$(texinfo_suffix_re_)' \
750 halt='found use of Texinfo @acronym{}' \
751 $(_sc_search_regexp)
61cd9dc9 752
c84bdaf6
LC
753cvs_keywords = \
754 Author|Date|Header|Id|Name|Locker|Log|RCSfile|Revision|Source|State
755
756sc_prohibit_cvs_keyword:
a927b6c1
LC
757 @prohibit='\$$($(cvs_keywords))\$$' \
758 halt='do not use CVS keyword expansion' \
759 $(_sc_search_regexp)
760
761# This Perl code is slightly obfuscated. Not only is each "$" doubled
762# because it's in a Makefile, but the $$c's are comments; we cannot
763# use "#" due to the way the script ends up concatenated onto one line.
764# It would be much more concise, and would produce better output (including
765# counts) if written as:
766# perl -ln -0777 -e '/\n(\n+)$/ and print "$ARGV: ".length $1' ...
767# but that would be far less efficient, reading the entire contents
768# of each file, rather than just the last two bytes of each.
769#
770# This is a perl script that is expected to be the single-quoted argument
771# to a command-line "-le". The remaining arguments are file names.
772# Print the name of each file that ends in two or more newline bytes.
773# Exit nonzero if at least one such file is found, otherwise, exit 0.
774# Warn about, but otherwise ignore open failure. Ignore seek/read failure.
775#
776# Use this if you want to remove trailing empty lines from selected files:
777# perl -pi -0777 -e 's/\n\n+$/\n/' files...
778#
779detect_empty_lines_at_EOF_ = \
780 foreach my $$f (@ARGV) \
781 { \
782 open F, "<", $$f or (warn "failed to open $$f: $$!\n"), next; \
783 my $$p = sysseek (F, -2, 2); \
784 my $$c = "seek failure probably means file has < 2 bytes; ignore"; \
785 my $$last_two_bytes; \
786 defined $$p and $$p = sysread F, $$last_two_bytes, 2; \
787 close F; \
788 $$c = "ignore read failure"; \
789 $$p && $$last_two_bytes eq "\n\n" and (print $$f), $$fail=1; \
790 } \
791 END { exit defined $$fail }
792sc_prohibit_empty_lines_at_EOF:
793 @perl -le '$(detect_empty_lines_at_EOF_)' $$($(VC_LIST_EXCEPT)) \
794 || { echo '$(ME): the above files end with empty line(s)' \
795 1>&2; exit 1; } || :; \
c84bdaf6
LC
796
797# Make sure we don't use st_blocks. Use ST_NBLOCKS instead.
798# This is a bit of a kludge, since it prevents use of the string
799# even in comments, but for now it does the job with no false positives.
800sc_prohibit_stat_st_blocks:
a927b6c1
LC
801 @prohibit='[.>]st_blocks' \
802 halt='do not use st_blocks; use ST_NBLOCKS' \
803 $(_sc_search_regexp)
c84bdaf6
LC
804
805# Make sure we don't define any S_IS* macros in src/*.c files.
806# They're already defined via gnulib's sys/stat.h replacement.
807sc_prohibit_S_IS_definition:
a927b6c1
LC
808 @prohibit='^ *# *define *S_IS' \
809 halt='do not define S_IS* macros; include <sys/stat.h>' \
810 $(_sc_search_regexp)
811
812_ptm1 = use "test C1 && test C2", not "test C1 -''a C2"
813_ptm2 = use "test C1 || test C2", not "test C1 -''o C2"
814# Using test's -a and -o operators is not portable.
815# We prefer test over [, since the latter is spelled [[ in configure.ac.
816sc_prohibit_test_minus_ao:
817 @prohibit='(\<test| \[+) .+ -[ao] ' \
818 halt='$(_ptm1); $(_ptm2)' \
819 $(_sc_search_regexp)
c84bdaf6 820
0f00f2c3
LC
821# Avoid a test bashism.
822sc_prohibit_test_double_equal:
823 @prohibit='(\<test| \[+) .+ == ' \
824 containing='#! */bin/[a-z]*sh' \
825 halt='use "test x = x", not "test x =''= x"' \
826 $(_sc_search_regexp)
827
61cd9dc9
LC
828# Each program that uses proper_name_utf8 must link with one of the
829# ICONV libraries. Otherwise, some ICONV library must appear in LDADD.
830# The perl -0777 invocation below extracts the possibly-multi-line
831# definition of LDADD from the appropriate Makefile.am and exits 0
832# when it contains "ICONV".
c84bdaf6
LC
833sc_proper_name_utf8_requires_ICONV:
834 @progs=$$(grep -l 'proper_name_utf8 ''("' $$($(VC_LIST_EXCEPT)));\
835 if test "x$$progs" != x; then \
836 fail=0; \
837 for p in $$progs; do \
838 dir=$$(dirname "$$p"); \
61cd9dc9
LC
839 perl -0777 \
840 -ne 'exit !(/^LDADD =(.+?[^\\]\n)/ms && $$1 =~ /ICONV/)' \
841 $$dir/Makefile.am && continue; \
c84bdaf6
LC
842 base=$$(basename "$$p" .c); \
843 grep "$${base}_LDADD.*ICONV)" $$dir/Makefile.am > /dev/null \
844 || { fail=1; echo 1>&2 "$(ME): $$p uses proper_name_utf8"; }; \
845 done; \
846 test $$fail = 1 && \
847 { echo 1>&2 '$(ME): the above do not link with any ICONV library'; \
848 exit 1; } || :; \
849 fi
850
851# Warn about "c0nst struct Foo const foo[]",
852# but not about "char const *const foo" or "#define const const".
853sc_redundant_const:
a927b6c1
LC
854 @prohibit='\bconst\b[[:space:][:alnum:]]{2,}\bconst\b' \
855 halt='redundant "const" in declarations' \
856 $(_sc_search_regexp)
c84bdaf6
LC
857
858sc_const_long_option:
859 @grep '^ *static.*struct option ' $$($(VC_LIST_EXCEPT)) \
860 | grep -Ev 'const struct option|struct option const' && { \
861 echo 1>&2 '$(ME): add "const" to the above declarations'; \
862 exit 1; } || :
863
864NEWS_hash = \
865 $$(sed -n '/^\*.* $(PREV_VERSION_REGEXP) ([0-9-]*)/,$$p' \
866 $(srcdir)/NEWS \
61cd9dc9
LC
867 | perl -0777 -pe \
868 's/^Copyright.+?Free\sSoftware\sFoundation,\sInc\.\n//ms' \
c84bdaf6
LC
869 | md5sum - \
870 | sed 's/ .*//')
871
872# Ensure that we don't accidentally insert an entry into an old NEWS block.
873sc_immutable_NEWS:
874 @if test -f $(srcdir)/NEWS; then \
875 test "$(NEWS_hash)" = '$(old_NEWS_hash)' && : || \
876 { echo '$(ME): you have modified old NEWS' 1>&2; exit 1; }; \
877 fi
878
879# Update the hash stored above. Do this after each release and
880# for any corrections to old entries.
881update-NEWS-hash: NEWS
882 perl -pi -e 's/^(old_NEWS_hash[ \t]+:?=[ \t]+).*/$${1}'"$(NEWS_hash)/" \
883 $(srcdir)/cfg.mk
884
885# Ensure that we use only the standard $(VAR) notation,
886# not @...@ in Makefile.am, now that we can rely on automake
887# to emit a definition for each substituted variable.
888# We use perl rather than "grep -nE ..." to exempt a single
889# use of an @...@-delimited variable name in src/Makefile.am.
61cd9dc9
LC
890# Allow the package to add exceptions via a hook in cfg.mk;
891# for example, @PRAGMA_SYSTEM_HEADER@ can be permitted by
892# setting this to ' && !/PRAGMA_SYSTEM_HEADER/'.
893_makefile_at_at_check_exceptions ?=
894sc_makefile_at_at_check:
895 @perl -ne '/\@[A-Z_0-9]+\@/'$(_makefile_at_at_check_exceptions) \
c84bdaf6
LC
896 -e 'and (print "$$ARGV:$$.: $$_"), $$m=1; END {exit !$$m}' \
897 $$($(VC_LIST_EXCEPT) | grep -E '(^|/)Makefile\.am$$') \
898 && { echo '$(ME): use $$(...), not @...@' 1>&2; exit 1; } || :
899
1cd4fffc 900news-check: NEWS
9157d901
LC
901 if sed -n $(news-check-lines-spec)p $(srcdir)/NEWS \
902 | grep -E $(news-check-regexp) >/dev/null; then \
c84bdaf6
LC
903 :; \
904 else \
1cd4fffc 905 echo 'NEWS: $$(news-check-regexp) failed to match' 1>&2; \
c84bdaf6
LC
906 exit 1; \
907 fi
908
909sc_makefile_TAB_only_indentation:
a927b6c1
LC
910 @prohibit='^ [ ]{8}' \
911 in_vc_files='akefile|\.mk$$' \
912 halt='found TAB-8-space indentation' \
913 $(_sc_search_regexp)
c84bdaf6
LC
914
915sc_m4_quote_check:
a927b6c1
LC
916 @prohibit='(AC_DEFINE(_UNQUOTED)?|AC_DEFUN)\([^[]' \
917 in_vc_files='(^configure\.ac|\.m4)$$' \
918 halt='quote the first arg to AC_DEF*' \
919 $(_sc_search_regexp)
c84bdaf6
LC
920
921fix_po_file_diag = \
922'you have changed the set of files with translatable diagnostics;\n\
923apply the above patch\n'
924
925# Verify that all source files using _() are listed in po/POTFILES.in.
926po_file = po/POTFILES.in
927sc_po_check:
928 @if test -f $(po_file); then \
929 grep -E -v '^(#|$$)' $(po_file) \
930 | grep -v '^src/false\.c$$' | sort > $@-1; \
931 files=; \
932 for file in $$($(VC_LIST_EXCEPT)) lib/*.[ch]; do \
933 test -r $$file || continue; \
934 case $$file in \
935 *.m4|*.mk) continue ;; \
936 *.?|*.??) ;; \
937 *) continue;; \
938 esac; \
939 case $$file in \
940 *.[ch]) \
941 base=`expr " $$file" : ' \(.*\)\..'`; \
942 { test -f $$base.l || test -f $$base.y; } && continue;; \
943 esac; \
944 files="$$files $$file"; \
945 done; \
946 grep -E -l '\b(N?_|gettext *)\([^)"]*("|$$)' $$files \
947 | sort -u > $@-2; \
948 diff -u -L $(po_file) -L $(po_file) $@-1 $@-2 \
949 || { printf '$(ME): '$(fix_po_file_diag) 1>&2; exit 1; }; \
950 rm -f $@-1 $@-2; \
951 fi
952
953# Sometimes it is useful to change the PATH environment variable
954# in Makefiles. When doing so, it's better not to use the Unix-centric
955# path separator of `:', but rather the automake-provided `$(PATH_SEPARATOR)'.
956msg = '$(ME): Do not use `:'\'' above; use $$(PATH_SEPARATOR) instead'
957sc_makefile_path_separator_check:
a927b6c1
LC
958 @prohibit='PATH[=].*:' \
959 in_vc_files='akefile|\.mk$$' \
960 halt=$(msg) \
961 $(_sc_search_regexp)
c84bdaf6
LC
962
963# Check that `make alpha' will not fail at the end of the process.
964writable-files:
965 if test -d $(release_archive_dir); then :; else \
966 for file in $(distdir).tar.gz \
967 $(release_archive_dir)/$(distdir).tar.gz; do \
968 test -e $$file || continue; \
969 test -w $$file \
970 || { echo ERROR: $$file is not writable; fail=1; }; \
971 done; \
972 test "$$fail" && exit 1 || : ; \
973 fi
974
2e65b52f 975v_etc_file = $(gnulib_dir)/lib/version-etc.c
c84bdaf6
LC
976sample-test = tests/sample-test
977texi = doc/$(PACKAGE).texi
978# Make sure that the copyright date in $(v_etc_file) is up to date.
979# Do the same for the $(sample-test) and the main doc/.texi file.
980sc_copyright_check:
a927b6c1
LC
981 @require='enum { COPYRIGHT_YEAR = '$$(date +%Y)' };' \
982 in_files=$(v_etc_file) \
983 halt='out of date copyright in $(v_etc_file); update it' \
984 $(_sc_search_regexp)
985 @require='# Copyright \(C\) '$$(date +%Y)' Free' \
986 in_vc_files=$(sample-test) \
987 halt='out of date copyright in $(sample-test); update it' \
988 $(_sc_search_regexp)
989 @require='Copyright @copyright\{\} .*'$$(date +%Y)' Free' \
990 in_vc_files=$(texi) \
991 halt='out of date copyright in $(texi); update it' \
992 $(_sc_search_regexp)
993
994# If tests/help-version exists and seems to be new enough, assume that its
995# use of init.sh and path_prepend_ is correct, and ensure that every other
996# use of init.sh is identical.
997# This is useful because help-version cross-checks prog --version
998# with $(VERSION), which verifies that its path_prepend_ invocation
999# sets PATH correctly. This is an inexpensive way to ensure that
1000# the other init.sh-using tests also get it right.
1001_hv_file ?= $(srcdir)/tests/help-version
1002_hv_regex_weak ?= ^ *\. .*/init\.sh"
1003_hv_regex_strong ?= ^ *\. "\$${srcdir=\.}/init\.sh"
1004sc_cross_check_PATH_usage_in_tests:
1005 @if test -f $(_hv_file); then \
1006 grep -l 'VERSION mismatch' $(_hv_file) >/dev/null \
1007 || { echo "$@: skipped: no such file: $(_hv_file)" 1>&2; \
1008 exit 0; }; \
1009 grep -lE '$(_hv_regex_strong)' $(_hv_file) >/dev/null \
1010 || { echo "$@: $(_hv_file) lacks conforming use of init.sh" 1>&2; \
1011 exit 1; }; \
1012 good=$$(grep -E '$(_hv_regex_strong)' $(_hv_file)); \
1013 grep -LFx "$$good" \
1014 $$(grep -lE '$(_hv_regex_weak)' $$($(VC_LIST_EXCEPT))) \
1015 | grep . && \
1016 { echo "$(ME): the above files use path_prepend_ inconsistently" \
1017 1>&2; exit 1; } || :; \
c84bdaf6
LC
1018 fi
1019
61cd9dc9
LC
1020# #if HAVE_... will evaluate to false for any non numeric string.
1021# That would be flagged by using -Wundef, however gnulib currently
1022# tests many undefined macros, and so we can't enable that option.
1023# So at least preclude common boolean strings as macro values.
1024sc_Wundef_boolean:
a927b6c1
LC
1025 @prohibit='^#define.*(yes|no|true|false)$$' \
1026 in_files='$(CONFIG_INCLUDE)' \
1027 halt='Use 0 or 1 for macro values' \
1028 $(_sc_search_regexp)
61cd9dc9
LC
1029
1030sc_vulnerable_makefile_CVE-2009-4029:
a927b6c1
LC
1031 @prohibit='perm -777 -exec chmod a\+rwx|chmod 777 \$$\(distdir\)' \
1032 in_files=$$(find $(srcdir) -name Makefile.in) \
0f00f2c3
LC
1033 halt=$$(printf '%s\n' \
1034 'the above files are vulnerable; beware of running' \
1035 ' "make dist*" rules, and upgrade to fixed automake' \
1036 ' see http://bugzilla.redhat.com/542609 for details') \
a927b6c1 1037 $(_sc_search_regexp)
61cd9dc9 1038
c84bdaf6
LC
1039vc-diff-check:
1040 (unset CDPATH; cd $(srcdir) && $(VC) diff) > vc-diffs || :
1041 if test -s vc-diffs; then \
1042 cat vc-diffs; \
1043 echo "Some files are locally modified:" 1>&2; \
1044 exit 1; \
1045 else \
1046 rm vc-diffs; \
1047 fi
1048
c84bdaf6
LC
1049rel-files = $(DIST_ARCHIVES)
1050
1051gnulib_dir ?= $(srcdir)/gnulib
1052gnulib-version = $$(cd $(gnulib_dir) && git describe)
1053bootstrap-tools ?= autoconf,automake,gnulib
1054
61cd9dc9
LC
1055# If it's not already specified, derive the GPG key ID from
1056# the signed tag we've just applied to mark this release.
1057gpg_key_ID ?= \
1058 $$(git cat-file tag v$(VERSION) > .ann-sig \
1059 && gpgv .ann-sig - < /dev/null 2>&1 \
1060 | sed -n '/.*key ID \([0-9A-F]*\)/s//\1/p'; rm -f .ann-sig)
1061
a927b6c1
LC
1062translation_project_ ?= coordinator@translationproject.org
1063announcement_Cc_ ?= $(translation_project_), $(PACKAGE_BUGREPORT)
1064announcement_mail_headers_ ?= \
1065To: info-gnu@gnu.org \
1066Cc: $(announcement_Cc_) \
1067Mail-Followup-To: $(PACKAGE_BUGREPORT)
1068
c84bdaf6
LC
1069announcement: NEWS ChangeLog $(rel-files)
1070 @$(build_aux)/announce-gen \
a927b6c1 1071 --mail-headers='$(announcement_mail_headers_)' \
c84bdaf6
LC
1072 --release-type=$(RELEASE_TYPE) \
1073 --package=$(PACKAGE) \
1074 --prev=$(PREV_VERSION) \
1075 --curr=$(VERSION) \
1076 --gpg-key-id=$(gpg_key_ID) \
61cd9dc9 1077 --news=$(srcdir)/NEWS \
c84bdaf6
LC
1078 --bootstrap-tools=$(bootstrap-tools) \
1079 --gnulib-version=$(gnulib-version) \
1080 --no-print-checksums \
1081 $(addprefix --url-dir=, $(url_dir_list))
1082
1083## ---------------- ##
1084## Updating files. ##
1085## ---------------- ##
1086
1087ftp-gnu = ftp://ftp.gnu.org/gnu
1088www-gnu = http://www.gnu.org
1089
dde9c5a4 1090upload_dest_dir_ ?= $(PACKAGE)
c84bdaf6
LC
1091emit_upload_commands:
1092 @echo =====================================
1093 @echo =====================================
1094 @echo "$(build_aux)/gnupload $(GNUPLOADFLAGS) \\"
dde9c5a4 1095 @echo " --to $(gnu_rel_host):$(upload_dest_dir_) \\"
c84bdaf6 1096 @echo " $(rel-files)"
61cd9dc9 1097 @echo '# send the ~/announce-$(my_distdir) e-mail'
c84bdaf6
LC
1098 @echo =====================================
1099 @echo =====================================
1100
c84bdaf6
LC
1101define emit-commit-log
1102 printf '%s\n' 'post-release administrivia' '' \
1103 '* NEWS: Add header line for next release.' \
1104 '* .prev-version: Record previous version.' \
1105 '* cfg.mk (old_NEWS_hash): Auto-update.'
1106endef
1107
1108.PHONY: no-submodule-changes
1109no-submodule-changes:
1110 if test -d $(srcdir)/.git; then \
1111 diff=$$(cd $(srcdir) && git submodule -q foreach \
1112 git diff-index --name-only HEAD) \
1113 || exit 1; \
1114 case $$diff in '') ;; \
1115 *) echo '$(ME): submodule files are locally modified:'; \
1116 echo "$$diff"; exit 1;; esac; \
1117 else \
1118 : ; \
1119 fi
1120
1121.PHONY: alpha beta stable
1122ALL_RECURSIVE_TARGETS += alpha beta stable
1123alpha beta stable: $(local-check) writable-files no-submodule-changes
1124 test $@ = stable \
1125 && { echo $(VERSION) | grep -E '^[0-9]+(\.[0-9]+)+$$' \
1126 || { echo "invalid version string: $(VERSION)" 1>&2; exit 1;};}\
1127 || :
1128 $(MAKE) vc-diff-check
1cd4fffc 1129 $(MAKE) news-check
c84bdaf6
LC
1130 $(MAKE) distcheck
1131 $(MAKE) dist XZ_OPT=-9ev
1cd4fffc
LC
1132 $(MAKE) $(release-prep-hook) RELEASE_TYPE=$@
1133 $(MAKE) -s emit_upload_commands RELEASE_TYPE=$@
1134
1135# Override this in cfg.mk if you follow different procedures.
1136release-prep-hook ?= release-prep
1137
0f00f2c3 1138gl_noteworthy_news_ = * Noteworthy changes in release ?.? (????-??-??) [?]
1cd4fffc
LC
1139.PHONY: release-prep
1140release-prep:
1141 case $$RELEASE_TYPE in alpha|beta|stable) ;; \
1142 *) echo "invalid RELEASE_TYPE: $$RELEASE_TYPE" 1>&2; exit 1;; esac
61cd9dc9 1143 $(MAKE) -s announcement > ~/announce-$(my_distdir)
c84bdaf6
LC
1144 if test -d $(release_archive_dir); then \
1145 ln $(rel-files) $(release_archive_dir); \
1146 chmod a-w $(rel-files); \
1147 fi
c84bdaf6
LC
1148 echo $(VERSION) > $(prev_version_file)
1149 $(MAKE) update-NEWS-hash
0f00f2c3 1150 perl -pi -e '$$. == 3 and print "$(gl_noteworthy_news_)\n\n\n"' NEWS
c84bdaf6
LC
1151 $(emit-commit-log) > .ci-msg
1152 $(VC) commit -F .ci-msg -a
61cd9dc9 1153 rm .ci-msg
c84bdaf6 1154
a927b6c1
LC
1155# Override this with e.g., -s $(srcdir)/some_other_name.texi
1156# if the default $(PACKAGE)-derived name doesn't apply.
1157gendocs_options_ ?=
1158
c84bdaf6
LC
1159.PHONY: web-manual
1160web-manual:
1161 @test -z "$(manual_title)" \
1162 && { echo define manual_title in cfg.mk 1>&2; exit 1; } || :
1163 @cd '$(srcdir)/doc'; \
a927b6c1
LC
1164 $(SHELL) ../build-aux/gendocs.sh $(gendocs_options_) \
1165 -o '$(abs_builddir)/doc/manual' \
c84bdaf6
LC
1166 --email $(PACKAGE_BUGREPORT) $(PACKAGE) \
1167 "$(PACKAGE_NAME) - $(manual_title)"
1168 @echo " *** Upload the doc/manual directory to web-cvs."
1169
1170# Code Coverage
1171
1172init-coverage:
1173 $(MAKE) $(AM_MAKEFLAGS) clean
1174 lcov --directory . --zerocounters
1175
1176COVERAGE_CCOPTS ?= "-g --coverage"
1177COVERAGE_OUT ?= doc/coverage
1178
1179build-coverage:
1180 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS)
1181 $(MAKE) $(AM_MAKEFLAGS) CFLAGS=$(COVERAGE_CCOPTS) CXXFLAGS=$(COVERAGE_CCOPTS) check
1182 mkdir -p $(COVERAGE_OUT)
1183 lcov --directory . --output-file $(COVERAGE_OUT)/$(PACKAGE).info \
1184 --capture
1185
1186gen-coverage:
1187 genhtml --output-directory $(COVERAGE_OUT) \
1188 $(COVERAGE_OUT)/$(PACKAGE).info \
1189 --highlight --frames --legend \
1190 --title "$(PACKAGE_NAME)"
1191
1192coverage: init-coverage build-coverage gen-coverage
1193
1194# Update gettext files.
1195PACKAGE ?= $(shell basename $(PWD))
1196PO_DOMAIN ?= $(PACKAGE)
1197POURL = http://translationproject.org/latest/$(PO_DOMAIN)/
1198PODIR ?= po
1199refresh-po:
1200 rm -f $(PODIR)/*.po && \
1201 echo "$(ME): getting translations into po (please ignore the robots.txt ERROR 404)..." && \
1202 wget --no-verbose --directory-prefix $(PODIR) --no-directories --recursive --level 1 --accept .po --accept .po.1 $(POURL) && \
1203 echo 'en@boldquot' > $(PODIR)/LINGUAS && \
1204 echo 'en@quot' >> $(PODIR)/LINGUAS && \
1205 ls $(PODIR)/*.po | sed 's/\.po//' | sed 's,$(PODIR)/,,' | sort >> $(PODIR)/LINGUAS
1206
a927b6c1 1207 # Running indent once is not idempotent, but running it twice is.
c84bdaf6
LC
1208INDENT_SOURCES ?= $(C_SOURCES)
1209.PHONY: indent
1210indent:
1211 indent $(INDENT_SOURCES)
a927b6c1 1212 indent $(INDENT_SOURCES)
c84bdaf6
LC
1213
1214# If you want to set UPDATE_COPYRIGHT_* environment variables,
1215# put the assignments in this variable.
1216update-copyright-env ?=
1217
1218# Run this rule once per year (usually early in January)
1219# to update all FSF copyright year lists in your project.
1220# If you have an additional project-specific rule,
1221# add it in cfg.mk along with a line 'update-copyright: prereq'.
1222# By default, exclude all variants of COPYING; you can also
1223# add exemptions (such as ChangeLog..* for rotated change logs)
1224# in the file .x-update-copyright.
1225.PHONY: update-copyright
1226update-copyright:
1227 grep -l -w Copyright \
1228 $$(export VC_LIST_EXCEPT_DEFAULT=COPYING && $(VC_LIST_EXCEPT)) \
1229 | $(update-copyright-env) xargs $(build_aux)/$@